#pragma once

#include "VRAMManager.h"
#include "Rect.h"

enum ETexFormat {ETF_RGBA4444,ETF_RGBA8888};

typedef struct {
  EVRAMManMode VMM;
  u32 psm;
  ETexFormat Format;
  u32 Width,Height;
  u32 LineSize;
  u32 ImgSize;
  u32 *pImg;
  bool Swizzled;
} TTexture;

extern bool Texture_Create(EVRAMManMode VMM,TTexture *ptex,ETexFormat Format,u32 Width,u32 Height);
extern void Texture_CreateFromFile(EVRAMManMode VMM,TTexture *ptex,ETexFormat Format,const char *pfn);
extern void Texture_Free(EVRAMManMode VMM,TTexture *ptex);

extern void Texture_Clear(TTexture *ptex);
extern void Texture_ExecuteSwizzle(TTexture *ptex);

extern void Texture_GU_Start(void);
extern void Texture_GU_End(void);
extern void Texture_GU_Draw(TTexture *ptex,s32 posx,s32 posy,u32 BaseColor);
extern void Texture_GU_DrawCustom(TTexture *ptex,s32 posx,s32 posy,u32 BaseColor,TRect Rect);

extern void TextureHelper_swizzle_fast(u8* out, const u8* in, unsigned int width, unsigned int height);

